// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from foros_msgs:msg/Inspector.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__MSG__DETAIL__INSPECTOR__FUNCTIONS_H_
#define FOROS_MSGS__MSG__DETAIL__INSPECTOR__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "foros_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "foros_msgs/msg/detail/inspector__struct.h"

/// Initialize msg/Inspector message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * foros_msgs__msg__Inspector
 * )) before or use
 * foros_msgs__msg__Inspector__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__msg__Inspector__init(foros_msgs__msg__Inspector * msg);

/// Finalize msg/Inspector message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__msg__Inspector__fini(foros_msgs__msg__Inspector * msg);

/// Create msg/Inspector message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * foros_msgs__msg__Inspector__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
foros_msgs__msg__Inspector *
foros_msgs__msg__Inspector__create();

/// Destroy msg/Inspector message.
/**
 * It calls
 * foros_msgs__msg__Inspector__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__msg__Inspector__destroy(foros_msgs__msg__Inspector * msg);

/// Check for msg/Inspector message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__msg__Inspector__are_equal(const foros_msgs__msg__Inspector * lhs, const foros_msgs__msg__Inspector * rhs);

/// Copy a msg/Inspector message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__msg__Inspector__copy(
  const foros_msgs__msg__Inspector * input,
  foros_msgs__msg__Inspector * output);

/// Initialize array of msg/Inspector messages.
/**
 * It allocates the memory for the number of elements and calls
 * foros_msgs__msg__Inspector__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__msg__Inspector__Sequence__init(foros_msgs__msg__Inspector__Sequence * array, size_t size);

/// Finalize array of msg/Inspector messages.
/**
 * It calls
 * foros_msgs__msg__Inspector__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__msg__Inspector__Sequence__fini(foros_msgs__msg__Inspector__Sequence * array);

/// Create array of msg/Inspector messages.
/**
 * It allocates the memory for the array and calls
 * foros_msgs__msg__Inspector__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
foros_msgs__msg__Inspector__Sequence *
foros_msgs__msg__Inspector__Sequence__create(size_t size);

/// Destroy array of msg/Inspector messages.
/**
 * It calls
 * foros_msgs__msg__Inspector__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
void
foros_msgs__msg__Inspector__Sequence__destroy(foros_msgs__msg__Inspector__Sequence * array);

/// Check for msg/Inspector message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__msg__Inspector__Sequence__are_equal(const foros_msgs__msg__Inspector__Sequence * lhs, const foros_msgs__msg__Inspector__Sequence * rhs);

/// Copy an array of msg/Inspector messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_foros_msgs
bool
foros_msgs__msg__Inspector__Sequence__copy(
  const foros_msgs__msg__Inspector__Sequence * input,
  foros_msgs__msg__Inspector__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // FOROS_MSGS__MSG__DETAIL__INSPECTOR__FUNCTIONS_H_
