// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from foros_msgs:msg/Inspector.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__MSG__DETAIL__INSPECTOR__STRUCT_HPP_
#define FOROS_MSGS__MSG__DETAIL__INSPECTOR__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__foros_msgs__msg__Inspector __attribute__((deprecated))
#else
# define DEPRECATED__foros_msgs__msg__Inspector __declspec(deprecated)
#endif

namespace foros_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Inspector_
{
  using Type = Inspector_<ContainerAllocator>;

  explicit Inspector_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cluster_name = "";
      this->cluster_size = 0ul;
      this->id = 0ul;
      this->state = 0;
      this->term = 0ull;
      this->data_size = 0ull;
      this->voted_for = 0ul;
    }
  }

  explicit Inspector_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init),
    cluster_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->cluster_name = "";
      this->cluster_size = 0ul;
      this->id = 0ul;
      this->state = 0;
      this->term = 0ull;
      this->data_size = 0ull;
      this->voted_for = 0ul;
    }
  }

  // field types and members
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;
  using _cluster_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _cluster_name_type cluster_name;
  using _cluster_size_type =
    uint32_t;
  _cluster_size_type cluster_size;
  using _id_type =
    uint32_t;
  _id_type id;
  using _state_type =
    uint8_t;
  _state_type state;
  using _term_type =
    uint64_t;
  _term_type term;
  using _data_size_type =
    uint64_t;
  _data_size_type data_size;
  using _voted_for_type =
    uint32_t;
  _voted_for_type voted_for;

  // setters for named parameter idiom
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }
  Type & set__cluster_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->cluster_name = _arg;
    return *this;
  }
  Type & set__cluster_size(
    const uint32_t & _arg)
  {
    this->cluster_size = _arg;
    return *this;
  }
  Type & set__id(
    const uint32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__state(
    const uint8_t & _arg)
  {
    this->state = _arg;
    return *this;
  }
  Type & set__term(
    const uint64_t & _arg)
  {
    this->term = _arg;
    return *this;
  }
  Type & set__data_size(
    const uint64_t & _arg)
  {
    this->data_size = _arg;
    return *this;
  }
  Type & set__voted_for(
    const uint32_t & _arg)
  {
    this->voted_for = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t UNKNOWN =
    0u;
  static constexpr uint8_t STANDBY =
    1u;
  static constexpr uint8_t FOLLOWER =
    2u;
  static constexpr uint8_t CANDIDATE =
    3u;
  static constexpr uint8_t LEADER =
    4u;
  static const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> TOPIC_NAME;

  // pointer types
  using RawPtr =
    foros_msgs::msg::Inspector_<ContainerAllocator> *;
  using ConstRawPtr =
    const foros_msgs::msg::Inspector_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<foros_msgs::msg::Inspector_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<foros_msgs::msg::Inspector_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      foros_msgs::msg::Inspector_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<foros_msgs::msg::Inspector_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      foros_msgs::msg::Inspector_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<foros_msgs::msg::Inspector_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<foros_msgs::msg::Inspector_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<foros_msgs::msg::Inspector_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__foros_msgs__msg__Inspector
    std::shared_ptr<foros_msgs::msg::Inspector_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__foros_msgs__msg__Inspector
    std::shared_ptr<foros_msgs::msg::Inspector_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Inspector_ & other) const
  {
    if (this->stamp != other.stamp) {
      return false;
    }
    if (this->cluster_name != other.cluster_name) {
      return false;
    }
    if (this->cluster_size != other.cluster_size) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->state != other.state) {
      return false;
    }
    if (this->term != other.term) {
      return false;
    }
    if (this->data_size != other.data_size) {
      return false;
    }
    if (this->voted_for != other.voted_for) {
      return false;
    }
    return true;
  }
  bool operator!=(const Inspector_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Inspector_

// alias to use template instance with default allocator
using Inspector =
  foros_msgs::msg::Inspector_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Inspector_<ContainerAllocator>::UNKNOWN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Inspector_<ContainerAllocator>::STANDBY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Inspector_<ContainerAllocator>::FOLLOWER;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Inspector_<ContainerAllocator>::CANDIDATE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Inspector_<ContainerAllocator>::LEADER;
#endif  // __cplusplus < 201703L
template<typename ContainerAllocator>
const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>
Inspector_<ContainerAllocator>::TOPIC_NAME = "foros/inspector";

}  // namespace msg

}  // namespace foros_msgs

#endif  // FOROS_MSGS__MSG__DETAIL__INSPECTOR__STRUCT_HPP_
