// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from foros_msgs:srv/RequestVote.idl
// generated code does not contain a copyright notice

#ifndef FOROS_MSGS__SRV__DETAIL__REQUEST_VOTE__TRAITS_HPP_
#define FOROS_MSGS__SRV__DETAIL__REQUEST_VOTE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "foros_msgs/srv/detail/request_vote__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace foros_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const RequestVote_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: term
  {
    out << "term: ";
    rosidl_generator_traits::value_to_yaml(msg.term, out);
    out << ", ";
  }

  // member: candidate_id
  {
    out << "candidate_id: ";
    rosidl_generator_traits::value_to_yaml(msg.candidate_id, out);
    out << ", ";
  }

  // member: last_data_index
  {
    out << "last_data_index: ";
    rosidl_generator_traits::value_to_yaml(msg.last_data_index, out);
    out << ", ";
  }

  // member: loat_data_term
  {
    out << "loat_data_term: ";
    rosidl_generator_traits::value_to_yaml(msg.loat_data_term, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RequestVote_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: term
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "term: ";
    rosidl_generator_traits::value_to_yaml(msg.term, out);
    out << "\n";
  }

  // member: candidate_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "candidate_id: ";
    rosidl_generator_traits::value_to_yaml(msg.candidate_id, out);
    out << "\n";
  }

  // member: last_data_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "last_data_index: ";
    rosidl_generator_traits::value_to_yaml(msg.last_data_index, out);
    out << "\n";
  }

  // member: loat_data_term
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "loat_data_term: ";
    rosidl_generator_traits::value_to_yaml(msg.loat_data_term, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RequestVote_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace foros_msgs

namespace rosidl_generator_traits
{

[[deprecated("use foros_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const foros_msgs::srv::RequestVote_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  foros_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use foros_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const foros_msgs::srv::RequestVote_Request & msg)
{
  return foros_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<foros_msgs::srv::RequestVote_Request>()
{
  return "foros_msgs::srv::RequestVote_Request";
}

template<>
inline const char * name<foros_msgs::srv::RequestVote_Request>()
{
  return "foros_msgs/srv/RequestVote_Request";
}

template<>
struct has_fixed_size<foros_msgs::srv::RequestVote_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<foros_msgs::srv::RequestVote_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<foros_msgs::srv::RequestVote_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace foros_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const RequestVote_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: term
  {
    out << "term: ";
    rosidl_generator_traits::value_to_yaml(msg.term, out);
    out << ", ";
  }

  // member: vote_granted
  {
    out << "vote_granted: ";
    rosidl_generator_traits::value_to_yaml(msg.vote_granted, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RequestVote_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: term
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "term: ";
    rosidl_generator_traits::value_to_yaml(msg.term, out);
    out << "\n";
  }

  // member: vote_granted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "vote_granted: ";
    rosidl_generator_traits::value_to_yaml(msg.vote_granted, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RequestVote_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace foros_msgs

namespace rosidl_generator_traits
{

[[deprecated("use foros_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const foros_msgs::srv::RequestVote_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  foros_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use foros_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const foros_msgs::srv::RequestVote_Response & msg)
{
  return foros_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<foros_msgs::srv::RequestVote_Response>()
{
  return "foros_msgs::srv::RequestVote_Response";
}

template<>
inline const char * name<foros_msgs::srv::RequestVote_Response>()
{
  return "foros_msgs/srv/RequestVote_Response";
}

template<>
struct has_fixed_size<foros_msgs::srv::RequestVote_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<foros_msgs::srv::RequestVote_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<foros_msgs::srv::RequestVote_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<foros_msgs::srv::RequestVote>()
{
  return "foros_msgs::srv::RequestVote";
}

template<>
inline const char * name<foros_msgs::srv::RequestVote>()
{
  return "foros_msgs/srv/RequestVote";
}

template<>
struct has_fixed_size<foros_msgs::srv::RequestVote>
  : std::integral_constant<
    bool,
    has_fixed_size<foros_msgs::srv::RequestVote_Request>::value &&
    has_fixed_size<foros_msgs::srv::RequestVote_Response>::value
  >
{
};

template<>
struct has_bounded_size<foros_msgs::srv::RequestVote>
  : std::integral_constant<
    bool,
    has_bounded_size<foros_msgs::srv::RequestVote_Request>::value &&
    has_bounded_size<foros_msgs::srv::RequestVote_Response>::value
  >
{
};

template<>
struct is_service<foros_msgs::srv::RequestVote>
  : std::true_type
{
};

template<>
struct is_service_request<foros_msgs::srv::RequestVote_Request>
  : std::true_type
{
};

template<>
struct is_service_response<foros_msgs::srv::RequestVote_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // FOROS_MSGS__SRV__DETAIL__REQUEST_VOTE__TRAITS_HPP_
